Mehrere Exceptions in einem Catch-Block abfangen

Bitte aktiviere JavaScript!
Hi, ich habe ein paar Fragen zu folgendem Konstrukt

Java:
        try {
            int result = divide();
            System.out.println(result);
        } catch (ArithmeticException | NoSuchElementException e) {
            System.out.println(e.toString());
            System.out.println("Unable to perform division.");
        }
1. Wie findet hier die Ausführungsreihenfolge innerhalb der Catch Anweisung statt?
Wird zuerst auf eine ArithmeticException und dann auf eine NoSuchElementException geprüft?

2. Warum kann ich nicht hinter jede Exception einen Namen für das Objekt stellen?
Weil ich für beide Exceptions in meinem Beispiel nur einen Block an Anweisungen habe?

3. Können beide Exceptions auf einmal zutreffen?

Falls ich mir die Fragen selber richtig beantwortet habe tut es mir Leid.
Hätte nur gerne eine Bestätigung falls ich richtig liege.
 
A

Anzeige




Vielleicht hilft dir unser Kurs hier weiter —> (hier klicken)
1. Wie findet hier die Ausführungsreihenfolge innerhalb der Catch Anweisung statt?
Wird zuerst auf eine ArithmeticException und dann auf eine NoSuchElementException geprüft?
Afaik ist das von links nach rechts. Da aber immer nur genau einer zutreffen kann, spielt das keine wirkliche Rolle.

2. Warum kann ich nicht hinter jede Exception einen Namen für das Objekt stellen?
Weil ich für beide Exceptions in meinem Beispiel nur einen Block an Anweisungen habe?
ArithmeticException | NoSuchElementException ist ein "Union-Type", das ganze ist also nur ein Typ. Unterschiedliche Bezeichnet machen aus deinem genannte Grund aber auch nur wenig Sinn.

3. Können beide Exceptions auf einmal zutreffen?
Nein. Es können weder zwei unterschiedliche Exceptions gleichzeitig geworfen werden (wie zB ArithmeticException und NoSuchElementException), noch kann ein Typ in einem Multicatch Subtyp eines anderen im gleichen Catch sein (wie bei IOException und FileNotFoundException).
 
ArithmeticException | NoSuchElementException ist ein "Union-Type", das ganze ist also nur ein Typ. Unterschiedliche Bezeichnet machen aus deinem genannte Grund aber auch nur wenig Sinn.
Heißt das ArithmeticException | NoSuchElementException wird als quasi ein Objekt betrachtet da ja nur ein Fall eintreffen kann?

Und mir ist noch eine Frage eingefallen:

Java:
public class ThrowAnException {

    public static void main(String[] args) {

        try {
            int result = divideInt(10, 5);
            System.out.println("10 durch 5 ergibt " + result);
            divideInt(10, 0);
            System.out.println("10 durch 0 ergibt " + result);
        } catch (ArithmeticException e) {
            e.printStackTrace();
        }
    }

    private static int divideInt(int i, int j) {
        if (j == 0) {
            throw new ArithmeticException("Divisor cannot be zero!");
        }
        return i / j;
    }

}
Wenn ich hier nun try/catch und den kompletten if-Block entferne bekomme ich eine ArithmeticException im StackTrace.
Falls ich den Code so lasse wie er ist und ArithmeticException im catch & throw stehen lasse geschieht das selbe.
Nun möchte ich aber den Code wie er ist wieder so lassen und ArithmeticException durch IllegalArgumentException austauschen. Warum funktioniert das? Im StackTrace habe ich nun die IllegalArgumentException, obwohl unchecked eine ArithmeticException auftaucht?
 
Naja, wenn du eine IllegalArgumentException wirfst, ist es doch klar, dass dann auch eine IllegalArgumentException kommt?
 
Naja, wenn du eine IllegalArgumentException wirfst, ist es doch klar, dass dann auch eine IllegalArgumentException kommt?
Unchecked ist es dann eine ArithmeticException und checked kann ich dann quasi selber entscheiden was ich werfen will?
Mich hat das zuerst nur verwirrt, da bei dem selben Fehler (Division durch 0) unterschiedliche Exceptions auftreten können.
 
Unchecked ist es dann eine ArithmeticException und checked kann ich dann quasi selber entscheiden was ich werfen will?
Checked Exceptions sind Exceptions, die man als Programmierer zwingend behandeln muss, entweder über fangen oder weiterwerfen, da sie zur Compiletime "gecheckt"werden.
Unchecked Exceptions (=Alle Unterklassen von RuntimeException) muss man nicht explizit behandeln (führen dann halt uU zum Absturz).

Sowohl ArithmeticException als auch IllegalArgumentException sind unchecked Exceptions.

Mich hat das zuerst nur verwirrt, da bei dem selben Fehler (Division durch 0) unterschiedliche Exceptions auftreten können.
Du selber wirst die Exception, das Teilen durch 0 kommt doch erst danach. Wenn du selber Exceptions wirfst, kannst du theoretisch werfen was du willst.
 
Zuletzt bearbeitet:
Passende Stellenanzeigen aus deiner Region:

Neue Themen

Oben